import matplotlib.pyplot as plt
import numpy as np
import os,math

base_dir = "./2021-11-23-alignments/"
files = [base_dir + f for f in os.listdir(base_dir) if f.endswith("2.txt")]

class base:
    def __init__(self):
        self.ref = "N"
        self.depth = 0
        self.vars = {}

#main_figure = plt.figure(figsize=(8, 6), dpi=300)
#main_figure_axis = main_figure.gca()
for ind,fname in enumerate(sorted(files)):
    pos = []
    refernce_bases = dict({(ind,"N") for ind in range(100000)})
    gridsize = int(math.sqrt(len(files)))
    #print (gridsize)
    #fig = plt.subplot(gridsize + int(gridsize*gridsize<len(files)), gridsize, ind+1)
    fig = plt.subplot(len(files), 1, ind+1)
    #fig = plt.subplot(len(files), 1, ind+1, figsize=(15,15))
    T_C = [0,0]
    A_G = [0,0]
    with open(fname) as f:
        for line in f:
            line = line.split()
            b = base()
            b.ref = line[2]
            b.ref_pos = int(line[1])
            b.depth = int(line[3])
            refernce_bases[b.ref_pos] = b.ref
            if b.depth == 0:
                continue
            for i in [5,6,7,8,9]:
                letter_info = line[i].split(":")
                b.vars[letter_info[0]] = int(letter_info[1])*100 / float(b.depth)
                if b.ref == "T" and letter_info[0] == "C":
                    T_C[0] += float(b.depth)
                    T_C[1] += int(letter_info[1])*100
                if b.ref == "A" and letter_info[0] == "G":
                    A_G[0] += float(b.depth)
                    A_G[1] += int(letter_info[1])*100
                    
            pos.append(b)


    print (fname,"T-->C SNPs: ", T_C, T_C[1]/T_C[0])
    print (fname,"A-->G SNPs: ",A_G, A_G[1]/A_G[0])
    X = range(len(pos))
    for l,colors in zip(["A","T","G","C"],["b","r","g","k"]):
        Y = [pos[i].vars[l] for i in range(len(pos))] #if pos[i].ref != l]
        X = [pos[i].ref_pos for i in range(len(pos))] #if pos[i].ref != l]
        fig.scatter(X,Y,color=colors,label=l,s=12)

    #plt.axvline(45,linestyle=":")
    #plt.axvline(62,linestyle=":")
    #if ind == len(files)-1:
    if True:
        plt.xticks(ticks=range(max(X)),
               labels=[refernce_bases[i] for i in range(max(X))]
               )
        plt.legend()
    else:
        plt.xticks(ticks=range(len(pos)),labels=[""]*len(pos))

    ax = plt.gca()
    ax.tick_params(axis='x', which='major', labelsize=6)

    plt.ylabel("Non-reference base, %",size=8)
    ax = plt.gca()
    ax.set_ylim([0, 1.5])
    sample_name = fname.split("_")[0][2:]
    m = str(np.median([pos[i].depth for i in range(len(pos))]))
    plt.title("Sample \""+sample_name+"\" Median coverage: "+ m)

plt.gcf().set_size_inches(35, 8)
plt.tight_layout()
#plt.show("fig.png")
print ("Saving figure...")
plt.savefig("fig2.png",dpi=300)
